import java.io.File;
import java.nio.ByteBuffer;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;

public class PackageContainer {
	private File arquivo;
	private FileInputStream stream;
	private BufferedInputStream dataBuffer;
	private final int SIZE =  1048576; //1 MB de buffer, equivalente a +- 2000 pacotes
	private final int DATA_PACKET = 500; //500 bytes de dados por pacote
	private byte pck;
	private int qtdPct;
	private long tamanhoUltimo;
	private int contador;
	
	
	public PackageContainer(File arquivo) throws IOException{
		this.arquivo = arquivo;
		contador = 0;
		stream = new FileInputStream(arquivo);
		dataBuffer = new BufferedInputStream(stream, SIZE);
		pck = 0;
		long tamanho = arquivo.length();
		double temp = tamanho/500D;
		qtdPct = (int) Math.ceil(temp);
		tamanhoUltimo = tamanho - ((qtdPct - 1)*500);
		
	}
	private byte[] intToByte(int value){
        return new byte[] {
                (byte)(value >>> 24),
                (byte)(value >>> 16),
                (byte)(value >>> 8),
                (byte)value};
	}
	public byte[] getNext() throws IOException {
		contador++;
		byte dataArray[];
	
		int leitura = 0;
		//System.out.println(contador+" "+qtdPct);
		if(contador == qtdPct){
			dataArray = new byte[(int)tamanhoUltimo+6];
			leitura =(int)tamanhoUltimo;
		}else{
			dataArray = new byte[506];
			leitura = DATA_PACKET;
		}
		
		int retorno = dataBuffer.read(dataArray, 6, leitura);
		if(retorno == -1){
			throw new IOException("end of file, no more packages");
		}
		byte tamanho[] = intToByte(leitura);
		dataArray[0] = pck;
		dataArray[1] = -1; //Data packet
		dataArray[2] = tamanho[0];
		dataArray[3] = tamanho[1];
		dataArray[4] = tamanho[2];
		dataArray[5] = tamanho[3];
		pck = (byte) (pck ^ 1);
		return dataArray;
	}
}
